# Ad-hoc Networking with Boe-Bot Simulation

![Alt text](/simBoeBot.png?raw=true)

## Structure of the Client
The Client is a multithreaded Python script with two major threads: one to handle 
input and sending and one to handle receiving ACKs from the Server.  

The Client is set to close when the user enters certain close commands, or the 
Server sends it a close command.

## Client Execution
When run, the client connects attempts to connect via Ethernet to the Server.

Once a user enters text and presses enter, the Client will send the string to the 
Server. If successful, an ACK should be summarily received by the Client’s other 
thread and printed.

## Structure of the Boe-Bot Sim
This program will simulate the Parallax Boe-Bot in the event that you are unable 
to have access to a physical Boe-Bot. The bulk of its activities will involve 
waiting for and parsing movement commands from the server and overlaying a 2D 
simulated robot performing those movements. Meanwhile, the console will provide 
helpful information for what is being processed. The code supports error and input 
validity handling, as well as multithreading for burst messaging support.

## Boe-Bot Sim Execution
The first line is a call to the future print function allowing IDE that support it 
to print console information only once, instead of continuously. It then moves to 
a Python version check so that the multithreading can be handled in 2.x and 3.x. 
The server’s Wi-Fi IP and port number are initialized and a connection is then 
made. At this point, a GUI will display which informs that it is waiting on server 
commands. The Draw() function handles the new GUI frames.

Skipping down to the code that actually starts this whole module is 
“thread.start_new_thread(receiver, ())”. This instructs the simulator to listen 
for incoming commands from the server. For each command set received, a new thread 
is created to handle parsing for individual instructions and acknowledging. Light 
data is generated and user input is error checked before commands are issued. With 
each movement, the robot sprite on screen is moved. The program exits when the 
command is “Close” or when either the server or client terminate on their end.

## Structure of the Server
The server does most of the work. It handles all of the messages and ACK’s for the 
client and the Boe-Bot. Each connection spawns its own thread and each message 
spawns its own thread. That way everything can happen simultaneously.

## Server Execution
Initially, the server will start the two main threads; one for handling client 
connections and the other for the Boe-Bot connection. Each connection then gets 
thrown into its own thread, where it waits for messages. The client thread wait 
for a message from the client, and spawns a new thread for it. The message is then 
sent to the Boe-Bot through the Boe-Bot message thread.

Meanwhile, the main Boe-Bot connection thread is waiting for messages from the 
Boe-Bot, which will either be an ACK or an exit statement. The server can also 
handle the client and/or the Boe-Bot disconnecting and reconnecting, all without 
error.

## Technical Details
<pre><code>
Client (Over Ethernet):
    IP: 10.5.10.2/255.255.255.0
Boe-Bot (Over Wi-Fi):
    IP: 192.168.173.2/255.255.255.0
Server:
    IP/port (Ethernet): 10.5.10.1:55555/255.255.255.0
    IP/port (Wi-Fi): 192.168.173.1:55556/255.255.255.0
</code></pre>