## Title: Server_Project_With_GUI.py
## Abstract:
## Author(s): Greg Greenleaf (pacohojaverde@gmail.com)
##            Alex Hauser (ahauser@csumb.edu)
##            Zac Leids (zleids@csumb.edu)
## Date: September 24, 2014

#This is the Python module that we will use to create the TCP sockets
import socket, sys, pygame, time
if (sys.version_info < (3,0)):
    import thread
else: import _thread as thread
pygame.init()
pygame.display.set_caption('Computer B: Server')

size = width, height = 640, 480
speed = [2, 2]
black = 0, 0, 0
BLUE  = (  0,   0, 255)

myList = [0]


listOfConnectedClients = []

ACKsSent = 0
connection = None
address = None
boeBotAddress = None
End = 0
screenChanged = True
connectionToBoeBot = None
connectionId = 0


#ip = "localhost" #Use this IP/port when testing on same PC
#port = 55555

ip = "10.5.10.1" #Use this IP/port when testing over Ethernet
port = 55555

ip2 = "192.168.173.1" #Use this ip/port for commmunication over wifi
port2 = 55556

#We create a socket object by using python's object initialization procedure ( socket.socket() )
ethernetSocket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
wifiSocket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
ethernetSocket.bind((ip, port))
wifiSocket.bind((ip2,port2))


#listen() says how many simultaneous clients the socket will connect to
ethernetSocket.listen(50)
wifiSocket.listen(2)
clients = []
print("Now waiting for a connections...\n")
buffer = ''

appendNumber = -1

ClientMessage = "Waiting for Client Connection..."
BoeBotMessage = "Waiting for Boe-Bot Connection..."

screen = pygame.display.set_mode(size)
basicfont = pygame.font.SysFont(None, 48)

def drawPoint(x, y):
    pygame.draw.line(screen, BLUE, (x, y), (x, y+1), 1)

def graphPoints(aList):
    for i in range(len(aList)):
        drawPoint(i, aList[i])

def Draw():
    text = basicfont.render(ClientMessage, True, (255, 0, 0), (255, 255, 255))
    textrect = text.get_rect()
    textrect.centerx = screen.get_rect().centerx
    textrect.centery = screen.get_rect().centery - 50

    text2 = basicfont.render(BoeBotMessage, True, (255, 0, 0), (255, 255, 255))
    textrect2 = text2.get_rect()
    textrect2.centerx = screen.get_rect().centerx
    textrect2.centery = screen.get_rect().centery + 25
   
    screen.fill(black)
   
    screen.blit(text, textrect)
    screen.blit(text2, textrect2)
     
    graphPoints(myList)
    
    pygame.display.flip()
    screenChanged = False;


def HandleBoeBotConnectionThread(address):
    global BoeBotMessage
    global connectionToBoeBot
    (ip, port) = address
    buffer = None
    ackClientMessage = None

    #print("\nHi I'm a new BoeBot Connection Handler thread")

    while buffer != 'Goodbye' and connectionToBoeBot:
            if connectionToBoeBot:
                #Reading information from the buffer, decoding it with utf-8
                try:
                    buffer = connectionToBoeBot.recv(1024).decode('utf-8')
 
                except:
                    print("Error, connection to BoeBot lost")
                    BoeBotMessage = str(ip) + " lost connection"
                    screenChanged = True
                    connectionToBoeBot = None
                    return

                #If the buffer has information, then we will go into the IF statement
                if buffer:
                    print("Boebot buffer: " + buffer)
                    if "Goodbye" in buffer:
                        BoeBotMessage = str(ip) + " disconnected. "
                        screenChanged = True
                        time.sleep(3)
                        BoeBotMessage = "Waiting for Boe-Bot Connection..."
                        screenChanged = True
                    BoeBotMessage = str(ip) + " Sent: " + buffer
                    thread.start_new_thread(HandleBoeBotMessageThread,(buffer,))
                    #ACK to be sent back to BoeBot
                    #ackBoeBotMessage = "ACK " + BoeBotMessage.split(":")[0] + ". BoeBotMessage recieved."
                    ackBoeBotMessage = str(ip) + ": " + buffer
                    #Sending the ACK ClientMessage, encoding it with utf-8
                    #connectionToBoeBot.send(ackBoeBotMessage.encode('utf-8'))

def HandleClientConnectionThread(connection, address, connectionId):
    global ClientMessage
    (ip, port) = address
    buffer = None
    ackClientMessage = None

    #print("\nHi I'm a new Client Connection Handler thread")

    while buffer != 'Goodbye' and connection:
            if connection:
                #Reading information from the buffer, decoding it with utf-8
                try:
                    buffer = connection.recv(1024).decode('utf-8')
 
                except:
                    print("Error, connection lost")
                    ClientMessage = str(ip) + " lost connection"
                    screenChanged = True
                    if connection in listOfConnectedClients:
                             listOfConnectedClients.remove(connection)
                    return

                #If the buffer has information, then we will go into the IF statement
                if buffer:
                    print("Client buffer: " + buffer)
                    if "Goodbye" in buffer:
                        #connectionToBoeBot = None
                        ClientMessage = str(ip) + " disconnected."
                        screenChanged = True
                        time.sleep(3)
                        ClientMessage = "Waiting for Client Connections..."
                        screenChanged = True
                        thread.exit()
                        return
                    thread.start_new_thread(HandleClientMessageThread,(buffer,))
                    ClientMessage = str(ip) + " Sent: " + buffer
                    #ACK to be sent back to Client
                    ackClientMessage = "ACK " + ClientMessage.split(":")[0] + ". ClientMessage received."
                    #Sending the ACK ClientMessage, encoding it with utf-8
                    connection.send(ackClientMessage.encode('utf-8'))

def HandleClientMessageThread(myClientMessage):
    global connection

    ackClientMessage = None
    msgSent = False
    myTimeout = 0
    buffer = None
    rcvMsg = None
    End = 0

    if "connect" in myClientMessage or "ACK" in myClientMessage or "Connected" in myClientMessage:
        return
    
    while End == 0:
        if connectionToBoeBot and myTimeout <= 0:
            thread.start_new_thread(HandleBoeBotMessageThread, (myClientMessage,))
            myTimeout = 1000
            msgSent = True
            

def HandleBoeBotMessageThread(myBoeBotMessage):
    global connectionToBoeBot

    ackBoeBotMessage = None
    msgSent = False
    myTimeout = 0
    buffer = None
    rcvMsg = None
    End = 0
    
    if "connect" in myBoeBotMessage or "ACK" in myBoeBotMessage or "Connected" in myBoeBotMessage:
        return

    while End == 0:
        
        if connectionToBoeBot and myTimeout <= 0:
            try:
                connectionToBoeBot.send(myBoeBotMessage.encode('utf-8'))
            except:
                print("Could not send message to Boe-Bot")
                connection.send("Could not send message to Boe-Bot".encode('utf-8'))
            myTimeout = 1000
            msgSent = True
            End = 1
        

def ServerClientFunctionality():
    global connection, address, screenChanged, ClientMessage, buffer, ACKsSent, ClientMessage, connectionId
    global appendNumber
    connectionId = 0
    while End == 0:
        #print("Looking for client connections")
        if len(listOfConnectedClients) < 1:
            ClientMessage = "Waiting for Client Connections..."
            #print("List of Connected Clients is less than 1")
            screenChanged = True

        connection, address = ethernetSocket.accept()
        #connection, address = wifiSocket.accept()
        listOfConnectedClients.append((connection, address))
        thread.start_new_thread(HandleClientConnectionThread,(connection, address,connectionId))
        connectionId+=1
        (ip, port) = address
        ClientMessage = str(ip) + " Connected"
        screenChanged = True

def ServerBoeBotFunctionality():
    global connectionToBoeBot, address, screenChanged, BoeBotMessage, buffer, ACKsSent, connectionId, appendNumber
    End = 0
    while End == 0:
        #print("Looking for BoeBot connection")
        if not connectionToBoeBot:
            BoeBotMessage = "Waiting for Boe-Bot Connection..."
            #print("Waiting for Boe-Bot Connection...")
            screenChanged = True

        connectionToBoeBot, address = wifiSocket.accept()        
        thread.start_new_thread(HandleBoeBotConnectionThread,(address,))
        connectionId+=1
        (ip, port) = address
        BoeBotMessage = str(ip) + " Connected"
        screenChanged = True

def sendCloseMessage(message):
    global connection, connectionToBoeBot
    if connection:
        connection.send(message.encode('utf-8'))
    if connectionToBoeBot:
        connectionToBoeBot.send(message.encode('utf-8'))
#start the main functions    
thread.start_new_thread(ServerClientFunctionality,())
thread.start_new_thread(ServerBoeBotFunctionality,())

while 1:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            thread.start_new_thread(sendCloseMessage, ("Close",))
            #Close()
            pygame.display.quit()
            sys.exit()
    if appendNumber > 0:
        myList.append(appendNumber)
        screenChanged = True
        appendNumber = -1

    if screenChanged == True:
        Draw();

print("Server sockets closing...")
#Closing the socket
ethernetSocket.close()
wifiSocket.close()
